/**
 cor-dialogue-window.js
 @package      Core
 @copyright    Copyright (c) 2007 - 2009 Ragnar.cz. All rights reserved
 @license      GNU/GPL http://www.gnu.org/copyleft/gpl.html

 Albireo is free software!
*/
	var w = 800;
    var diaIDsCounter = 1;

    function getNewDiaID () {
        newID = "albireoDialogue"+ diaIDsCounter;
        diaIDsCounter = diaIDsCounter +1;
        return newID;
    }

    function ajaxDialogue ( dest ) { // creates dialogue with answer based on Ajax throught GET
        newID = getNewDiaID ();
    	dialogueWindow ( newID, "Albireo", '<img src="styles/cor-admin/loading.gif" class="center" /><br /><input type="button" class="dialoguebutton" onclick="closeDialogueWindow(\''+newID+'\');" value="OK" />' );

		// we wait for request 40 seconds
		var successfulEnd = setTimeout ( function () {
            ( "#"+newID ).html('<p><strong class="warning">Komunikace se serverem stále probíhá.</strong></p><img src="styles/cor-admin/loading.gif" class="center" /><br /><input type="button" class="dialoguebutton" onclick="closeDialogueWindow(\''+newID+'\');" value="Zavřít" />');
            dialogueButtons ();
            successfulEnd = setTimeout ( function () {
                $( "#"+newID ).html('<p><strong class="warning">Server stále neodeslal žádnou odpověď. Komunikace však může stále probíhat.</strong></p><img src="styles/cor-admin/loading.gif" class="center" /><br /><input type="button" class="dialoguebutton" onclick="closeDialogueWindow(\''+newID+'\');" value="Zavřít" />');
                dialogueButtons ();
            }, 30000 );
		}, 10000 );

        $.ajax({
             type: "GET",
             dataType: "html",
             url: dest,
             cache: false,
             success: function ( html ) {
                 clearTimeout ( successfulEnd );
				 changeDialogue ( newID, html );
             },
             error: function ( html ){
                 clearTimeout ( successfulEnd );
                 $( "#"+newID ).html( '<p>Chyba při komunikaci se serverem.</p><input type="button" class="dialoguebutton" onclick="closeDialogueWindow(\''+newID+'\');" value="OK" />' )
                 dialogueButtons ();
             }
         });
    }
	
    function ajaxWidthDialogue ( dest, myw ) { // creates dialogue with answer based on Ajax throught GET
		w = myw;
        ajaxDialogue(dest);
    }

    function changeWidthDialogueByGET ( id, url, width ) {
        w = width;
        changeDialogueByGET ( id, url );
    }

    function convertDialogueContents ( html, id ) {
        html = html.replace ( /changeDialogueByPost\s??\(/g, "changeDialogueByPost('"+id+"'," );
        html = html.replace ( /changeDialogueByGET\s??\(/g, "changeDialogueByGET('"+id+"'," );
        html = html.replace ( /changeWidthDialogueByGET\s??\(/g, "changeWidthDialogueByGET('"+id+"'," );
        html = html.replace ( /closeDialogueWindow\s??\(\s*\)/g, "closeDialogueWindow('"+id+"')" );
        html = html.replace ( /\+\+dialogueID\+\+/g, id );
        return html;
    }
	
    function changeDialogue ( id, html ) {
        if ( $( "#"+ id ).dialog( "option", "width" ) != w ) {
            $( "#"+ id ).dialog ( 'close' );
            $( "#"+ id ).remove ();
            $( "body" ).append ( "<div id='"+ id +"' class='flora'></div>" );
        }
        html = convertDialogueContents ( html, id );
        // we are working with xml as text because the world isn`t prepared for pure valid xml
        if ( html.indexOf ( "<body>" ) ) {
            $( "#"+ id ).html( html.substring ( html.indexOf ( "<body>" ) + 6, html.indexOf ( "</body>" ) ) );
            $( "#"+ id ).attr( "title", html.substring ( html.indexOf ( "<title>" )+7, html.indexOf ( "</title>" ) ) );
        } else if ( html.length > 0 ) {
            $( "#"+ id ).html ( html );
        } else {
            $( "#"+ id ).html( '<p><strong class="warning">Odpověď nemá žádný obsah!</strong></p><input type="button" class="dialoguebutton" onclick="closeDialogueWindow();" value="OK" />');
        }
        if ( $( "#"+ id ).dialog( "option", "width" ) != w ) $( "#"+id ).dialog( { width: w,close: function(event, ui) { $( "#"+id ).remove (); } } );
        $( "#"+ id ).dialog( "option", "position", "center" );
        dialogueButtons();
        w = 800;
    }

    function dialogueWindow ( id, title, content ) { // creates html of dialogue window
        content = convertDialogueContents ( content, id );
        $( "body" ).append( "<div id='"+id+"' class='flora' title='"+title+"'>"+content+"</div>" );
        $( "#"+id ).dialog( { width: w, close: function(event, ui) { $( "#"+id ).remove (); } } );
        dialogueButtons();
    }

    function modalDialogueWindow ( id, title, content ) { // creates html of dialogue window
        content = convertDialogueContents ( content, id );
        $( "body" ).append( "<div id='"+id+"' class='flora' title='"+title+"'>"+content+"</div>" );
        $( "#"+id ).dialog( { width: w, modal: true, close: function(event, ui) { $( "#"+id ).remove (); } } );
        dialogueButtons();
    }

    function closeDialogueWindow ( id ) { // close dialogue window
        if ( $( "#"+id ).dialog ( "isOpen" ) ) {
            $( "#"+id ).dialog ( "close" );
            $( "#"+id ).remove ();
        }
    }

    function confirmDialogue ( title, text, dest ) { // creates confirm dialogue
        w = 550;
        newID = getNewDiaID ();
    	var diaText = '<p>' + text + '</p><input type="button" class="dialoguebutton" onclick="window.location=\''+ dest +'\';" value="Ano" /><input type="button" class="dialoguebutton" onclick="closeDialogueWindow(\''+newID+'\');" value="Ne" />';
    	dialogueWindow ( newID, title, diaText );
    	return false;
    }
	
    function okDialogue ( title, text ) { // creates dialogue with OK button
        w = 550;
        newID = getNewDiaID ();
        var diaText = '<p>' + text + '</p><input type="button" class="dialoguebutton" onclick="closeDialogueWindow(\''+newID+'\');" value="OK" />';
        dialogueWindow ( newID, title, diaText );
    	return false;
    }

    function dialogueButtons () {
        $(".dialoguebutton").css("height","30px");
        $(".dialoguebutton").css("width","200px");
        $(".dialoguebutton").css("margin","10px 0px 5px 0px");
        $(".dialoguebutton").css("text-align","center");
        $(".dialoguebutton").css("background","#0078ae url(styles/jquerytheme/images/ui-bg_glass_45_0078ae_1x400.png) 50% 50% repeat-x");
        $(".dialoguebutton").css("border","1px solid #77d5f7");
        $(".dialoguebutton").css("color","#fff");
        $(".dialoguebutton").css("cursor","hand");
        $(".dialoguebutton").css("cursor","pointer");
        $(".dialoguebutton").mouseover(function(event){
            $(event.target).css("border","1px solid #448dae");
            $(event.target).css("background","#79c9ec url(styles/jquerytheme/images/ui-bg_glass_75_79c9ec_1x400.png) 50% 50% repeat-x");
            $(event.target).css("color","#026890");
        }).mouseout(function(event){
            $(event.target).css("border","1px solid #77d5f7");
            $(event.target).css("background","#0078ae url(styles/jquerytheme/images/ui-bg_glass_45_0078ae_1x400.png) 50% 50% repeat-x");
            $(event.target).css("color","#fff");
        });
    }